3 # Copyright (c) 2005 Junio C Hamano
5 # Fetch one or more remote refs and merge it/them into the current HEAD.
7 USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff|--ff-only] [--[no-]rebase|--rebase=preserve] [-s strategy]... [<fetch-options>] <repo> <head>...'
8 LONG_USAGE='Fetch one or more remote refs and integrate it/them with the current HEAD.'
13 set_reflog_action "pull${1+ $*}"
14 require_work_tree_exists
19 git diff-index --cached --name-status -r --ignore-submodules HEAD --
20 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
21 die "$(gettext "Pull is not possible because you have unmerged files.
22 Please, fix them up in the work tree, and then use 'git add/rm <file>'
23 as appropriate to mark resolution and make a commit.")"
25 die "$(gettext "Pull is not possible because you have unmerged files.")"
30 if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
31 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
32 Please, commit your changes before you can merge.")"
34 die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
38 test -z "$(git ls-files -u)" || die_conflict
39 test -f "$GIT_DIR/MERGE_HEAD" && die_merge
41 bool_or_string_config () {
42 git config --bool "$1" 2>/dev/null || git config "$1"
45 strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
46 log_arg= verbosity= progress= recurse_submodules= verify_signatures=
47 merge_args= edit= rebase_args=
48 curr_branch=$(git symbolic-ref -q HEAD)
49 curr_branch_short="${curr_branch#refs/heads/}"
50 rebase=$(bool_or_string_config branch.$curr_branch_short.rebase)
53 rebase=$(bool_or_string_config pull.rebase)
56 # Setup default fast-forward options via `pull.ff`
57 pull_ff=$(bool_or_string_config pull.ff)
76 verbosity="$verbosity -q" ;;
78 verbosity="$verbosity -v" ;;
80 progress=--progress ;;
82 progress=--no-progress ;;
83 -n|--no-stat|--no-summary)
87 --log|--log=*|--no-log)
89 --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
90 no_commit=--no-commit ;;
91 --c|--co|--com|--comm|--commi|--commit)
97 --sq|--squ|--squa|--squas|--squash)
99 --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
100 squash=--no-squash ;;
107 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
108 --strateg=*|--strategy=*|\
109 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
112 strategy=$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
119 strategy_args="${strategy_args}-s $strategy "
126 xx="-X $(git rev-parse --sq-quote "$2")"
129 xx=$(git rev-parse --sq-quote "$1") ;;
131 merge_args="$merge_args$xx "
133 -r=*|--r=*|--re=*|--reb=*|--reba=*|--rebas=*|--rebase=*)
136 -r|--r|--re|--reb|--reba|--rebas|--rebase)
139 --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
142 --recurse-submodules)
143 recurse_submodules=--recurse-submodules
145 --recurse-submodules=*)
146 recurse_submodules="$1"
148 --no-recurse-submodules)
149 recurse_submodules=--no-recurse-submodules
152 verify_signatures=--verify-signatures
154 --no-verify-signatures)
155 verify_signatures=--no-verify-signatures
161 gpg_sign_args=$(git rev-parse --sq-quote "-S${1#--gpg-sign=}")
164 gpg_sign_args=$(git rev-parse --sq-quote "$1")
166 --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
173 # Pass thru anything that may be meant for fetch.
183 rebase_args=--preserve-merges
188 echo "Invalid value for --rebase, should be true, false, or preserve"
194 error_on_no_merge_candidates () {
197 if test true = "$rebase"
206 upstream=$(git config "branch.$curr_branch_short.merge")
207 remote=$(git config "branch.$curr_branch_short.remote")
209 if [ $# -gt 1 ]; then
210 if [ "$rebase" = true ]; then
211 printf "There is no candidate for rebasing against "
213 printf "There are no candidates for merging "
215 echo "among the refs that you just fetched."
216 echo "Generally this means that you provided a wildcard refspec which had no"
217 echo "matches on the remote end."
218 elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
219 echo "You asked to pull from the remote '$1', but did not specify"
220 echo "a branch. Because this is not the default configured remote"
221 echo "for your current branch, you must specify a branch on the command line."
222 elif [ -z "$curr_branch" -o -z "$upstream" ]; then
224 error_on_missing_default_upstream "pull" $op_type $op_prep \
225 "git pull <remote> <branch>"
227 echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
228 echo "from the remote, but no such ref was fetched."
233 test true = "$rebase" && {
234 if ! git rev-parse -q --verify HEAD >/dev/null
236 # On an unborn branch
237 if test -f "$(git rev-parse --git-path index)"
239 die "$(gettext "updating an unborn branch with changes added to the index")"
242 require_clean_work_tree "pull with rebase" "Please commit or stash them."
245 test -n "$curr_branch" &&
246 . git-parse-remote &&
247 remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
248 oldremoteref=$(git merge-base --fork-point "$remoteref" $curr_branch 2>/dev/null)
250 orig_head=$(git rev-parse -q --verify HEAD)
251 git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
252 test -z "$dry_run" || exit 0
254 curr_head=$(git rev-parse -q --verify HEAD)
255 if test -n "$orig_head" && test "$curr_head" != "$orig_head"
257 # The fetch involved updating the current branch.
259 # The working tree and the index file is still based on the
260 # $orig_head commit, but we are merging into $curr_head.
261 # First update the working tree to match $curr_head.
263 eval_gettextln "Warning: fetch updated the current branch head.
264 Warning: fast-forwarding your working tree from
265 Warning: commit \$orig_head." >&2
266 git update-index -q --refresh
267 git read-tree -u -m "$orig_head" "$curr_head" ||
268 die "$(eval_gettext "Cannot fast-forward your working tree.
269 After making sure that you saved anything precious from
270 $ git diff \$orig_head
277 merge_head=$(sed -e '/ not-for-merge /d' \
278 -e 's/ .*//' "$GIT_DIR"/FETCH_HEAD | \
281 case "$merge_head" in
283 error_on_no_merge_candidates "$@"
286 if test -z "$orig_head"
288 die "$(gettext "Cannot merge multiple branches into empty head")"
290 if test true = "$rebase"
292 die "$(gettext "Cannot rebase onto multiple branches")"
297 # Pulling into unborn branch: a shorthand for branching off
298 # FETCH_HEAD, for lazy typers.
299 if test -z "$orig_head"
301 # Two-way merge: we claim the index is based on an empty tree,
302 # and try to fast-forward to HEAD. This ensures we will not
303 # lose index/worktree changes that the user already made on
305 empty_tree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
306 git read-tree -m -u $empty_tree $merge_head &&
307 git update-ref -m "initial pull" HEAD $merge_head "$curr_head"
311 if test true = "$rebase"
313 o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
314 if test "$oldremoteref" = "$o"
322 eval="git-rebase $diffstat $strategy_args $merge_args $rebase_args $verbosity"
323 eval="$eval $gpg_sign_args"
324 eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
327 eval="git-merge $diffstat $no_commit $verify_signatures $edit $squash $no_ff $ff_only"
328 eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
329 eval="$eval $gpg_sign_args"
330 eval="$eval FETCH_HEAD"